/* mp3 live server version 0.02 */
/* Copyright Scott Manley 1997 */
/* This Software is protected under the terms of the Gnu Public License */
/* All code is original*/

/* history                                                                  */
/* v0.01 - OK decided that I need to Give things version No.s               */
/*         Made the reflector clever enough to strip of garbage before      */
/*                  headers from a reflected stream                         */
/*         Reflector Strips of >1024 bytes from head of stream to make live */
/*                  headers consistent                                      */
/*         The header.mp3 file is not used any more but is still generated  */
/*                  I can't rememebr why ;-) but I had a reason earlier     */
/*                  (I now rememebr it's for using multiple live files      */
/*                   To save on disk space)                                 */
/*         Standardised the error Reporting system                          */
/*         Add checks to see if live.mp3 is increasing with time            */

/* v0.02   Did the decent thing and split the code into lots of files       */
/*         Created proper command line configuration options                */
/*         Created extra maintenance process for controling number of       */
/*                  open connections and other stuff                        */

#include <stdlib.h>
#include <math.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <netdb.h>
#include <netinet/in.h>
#include <string.h>
#include <time.h>
#include <unistd.h>
#include <errno.h>
#include <signal.h>
#include <netdb.h>
#include <arpa/inet.h>          

/* Default port */
#define PORT 3223

/* How far from the end of the live stream can we rewind */
#define REW_BYTES 1024

#define S_DELAY 0
#define S_NDELAY 1

#define S_RESET 0
#define S_SET 1
#define S_NAMLEN 64

/* some socket stuff */
typedef struct{
    struct sockaddr_in sin;
    int sinlen;
    int bindflag;
    int sd;
} sckt;


/* general server stuff */
typedef struct{
  int serv_port;
  int mnt_port;
  int server;             /* are we a server or a reflector */
  char *reflector;
  int reflector_port;
  char *mnt_pipe;         /* name of pipe for Maintenace process */
  char *snd_pipe;         /* name of pipe for sound processing */
  char *header_file;      /* name of file used to store header */
  char *live_file;        /* name of file for live data */
  char *log_file;         /* name of file for logging */
  int limit;              /* maximum no. of allowable subprocesses */
} config;


/* other functions */

void fatal(char *text);
int sserver(sckt *sp, int port, int sync);
int sclient(sckt *sp, char *name, int port);
sckt *sopen(void);
int sclose(sckt *sp);
int valid(unsigned long); 

void maintain_server(config conf);
void start_server(config conf);
void report(char *str,FILE *mnt);
