/* All code for making connections goes in here */
#include "mp3serv.h"

extern int errno;

/* If nothing is read or written for 30 seconds then Die */
/* Probably need some more reporting                     */
void timeout(){
  signal (SIGALRM, SIG_IGN);
  exit(0);
}

void arm ( unsigned int secs){
if (secs == 0) {                      /* reset */
  signal (SIGALRM, SIG_IGN);
  alarm (0);
} else {                              /* set */
  signal (SIGALRM, timeout);
  alarm (secs);
} 
} 


void write_header(int sd,FILE *in){
unsigned char c,buffer[2048];
unsigned long header;
int len1,len2,seek,bcount,fragment,b,bptr,opterr;

/*first send HTTP header */
len1=sprintf(buffer,"HTTP/1.0 200 OK\nServer: Szyzyg's MP3 Daemon\nContent-type: audio/x-mpeg\n\n");
write(sd,buffer,len1);

 fread(buffer,1,2048,in);
header=((unsigned long) buffer[1024] << 24) | ((unsigned long) buffer[1025] << 16) |  ((unsigned long) buffer[1026] << 8)  | (unsigned long) buffer[1027];
bptr=1024;
while(!valid(header)){
  c=buffer[bptr+4];
  bptr++;
  header <<= 8;
  header |= (unsigned long) c;
  header &= 0xffffffff;
  if(bptr>2048)
    fatal("mp3 header seek");
}
write(sd,buffer,bptr);
arm(30);
}


void seek_end(FILE *in){
unsigned char c,buffer[2048];
int len1,len2,seek,bcount,fragment,b,bptr,opterr;
unsigned long header;
fseek(in,-1024,SEEK_END);
/*now look for a valid mp3 frame header */
bptr=0;
fread(buffer,1,4,in);
header=((unsigned long) buffer[0] << 24) | ((unsigned long) buffer[1] << 16) |  ((unsigned long) buffer[2] << 8)  | (unsigned long) buffer[3];
while(!valid(header) ){
  c=fgetc(in);
  header <<= 8;
  header |= (unsigned long) c;
  header &= 0xffffffff;
  bptr ++;
  if(bptr>1024)
    fatal("mp3 header seek");
}
fseek(in,-4,SEEK_CUR);
}

/* again most of the error checking has been thrown out */
int write_frames(int sd,FILE *in){
int len1,len2;
unsigned char c,buffer[2048];

len1=fread(buffer,1,2048,in);
write(sd,buffer,len1);
if(feof(in))
  usleep(100000);
}

/* this probably needs some terminating condition */
void servemp3(int sd,sckt *sp,FILE *mnt,config conf) {
FILE *in;
char ip_addr[32];
int delay;
long p1,p2;

sprintf(ip_addr,"[%.32s]", inet_ntoa(sp->sin.sin_addr));
fprintf(mnt,"%6d:A %s\n",getpid(),ip_addr);
arm(30);
delay=0;
if((in=fopen(conf.live_file,"rb"))==NULL)
  fatal("opening live file");
write_header(sd,in);
fprintf(mnt,"%6d:H\n",getpid());
seek_end(in);
while(1){
  delay+=write_frames(sd,in);
  arm(30);
  delay++;
  if(delay>16000){
    p1=ftell(in);
    fseek(in,0,SEEK_END);
    p2=ftell(in);
    fseek(in,p1,SEEK_SET);
    fprintf(mnt,"%6d:W %ld %ld\n",getpid(),delay,p2-p1);
    delay=0;
  }
}
close(sd);
exit(0);
}



void start_server(config conf){
  sckt *sp;
  FILE *mnt;
  int sd;
  int open;
  mnt=fopen(conf.mnt_pipe,"w");
  fprintf(mnt,"%6d:O %d\n",getpid(),conf.serv_port);
  
  /*generate a socket*/
  if ((sp = sopen())==0)
    fatal("sopen()");
  open=0;
  while(1){
    /* Need Proper Action here - to clean up the whole system */
    if ((sd = sserver(sp, conf.serv_port, S_DELAY))==-1)
      fatal("sserver() - couldn't open port for listening");
    /* Fork() a child process */
    switch (fork())
      {
      case 0:
	servemp3(sd,sp,mnt,conf);
	
      case -1:
	fatal("fork()");
      }
    close(sd);
    open++;
    /* If we've spawned more kids than we are allowed to then wait for one
       to terminate before listening for new ones*/
    if(open>=conf.limit){
      wait();
      open--;
    }
  }
}

